package com.xuxueli.executor.sample.nutz.jobhandler;

import java.util.concurrent.TimeUnit;

import org.nutz.ioc.loader.annotation.IocBean;

import com.xxl.job.core.biz.model.ReturnT;
import com.xxl.job.core.handler.IJobHandler;
import com.xxl.job.core.log.XxlJobLogger;


/**
 * 任务Handler的一个Demo（Bean模式）
 *
 * 开发步骤：
 * 1、继承 “IJobHandler” ；
 * 2、执行日志：需要通过 "XxlJobLogger.log" 打印执行日志；
 * 3、在 "JFinalCoreConfig" 中注册，执行Jobhandler名称；
 *
 * @author xuxueli 2015-12-19 19:43:36
 */
@IocBean
public class DemoJobHandler extends IJobHandler {

	@Override
	public ReturnT<String> execute(String... params) throws Exception {
		XxlJobLogger.log("XXL-JOB, Hello World.");

		for (int i = 0; i < 5; i++) {
			XxlJobLogger.log("beat at:" + i);
			TimeUnit.SECONDS.sleep(2);
		}
		return ReturnT.SUCCESS;
	}

}
